/*

    Zelda Return of the Hylian

    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "Texte.h"
#include "Menu.h"
#include "Joueur.h"
#include "Monde.h"
#include "Projectile.h"
#include "Jeu.h"

Texte::Texte(Jeu* jeu) : gpJeu(jeu), vitesse(40), av(0), x(0), y(0), w(0), h(0),
id(0), idsuiv(0), def(false), cadre(false), texte(""), buffer("") {
    lastAnimTime = SDL_GetTicks();
    imageFont = IMG_Load("data/images/texte/font.png");
    SDL_SetColorKey(imageFont,SDL_SRCCOLORKEY,SDL_MapRGB(imageFont->format,0,0,255));
    imageCoeur = IMG_Load("data/images/menu/coeur.png");
    SDL_SetColorKey(imageCoeur,SDL_SRCCOLORKEY,SDL_MapRGB(imageCoeur->format,0,0,255));
}

Texte::~Texte() {
    SDL_FreeSurface(imageFont);
    SDL_FreeSurface(imageCoeur);
}

void Texte::chercheText() {
    ostringstream os;
    int tmp;
    switch (id) {
        case 1  : texte = "Vous avez trouv 2 boucliers !!!**Vos dfenses augmentent d'un point !"; break;
        case 2  : texte = "Vous avez trouv 2 pes !!!**Vous allez pouvoir vous dfendre face aux monstres avec les touches W et R !!!*Maintienez W ou R enfonc pour charger une attaque cyclone !!!"; break;
        case 3  : 
            tmp = 4-(gpJeu->getJoueur()->nbQuarts()%4);
            os << tmp;
            texte = "Vous avez trouv un quart de coeur !!!";
            if (tmp<4) buffer = "Encore "+os.str()+" et vous gagnerez un coeur supplmentaire !!!";
            else buffer = "Vos nombres de coeurs viennent d'augmenter !!!";
            break;
        case 11 : texte = "N : Maison des frres Link*O : Plaine d'Hyrule*E : Temple de la Fort"; break;
        case 12 : texte = "Temple de la Montagne**Dconseill aux cardiaques, peureux, et aux mes sensibles en gnral."; break;
        case 13 : texte = "O : Entre du Dsert*N : Temple de la Montagne"; break;
        case 14 : texte = "N : Temple de la Montagne*S : Plaine d'Hyrule"; break;
        case 15 : texte = "N : Mont du Pril"; break;
        case 16 : texte = "E : Entre de la Fort"; break;
        case 17 : texte = "S : Lac Hylia*E : Cimetire Hant"; break;
        case 18 : texte = "S : Vers le Village Cocorico"; break;
        case 19 : texte = "N : Village Cocorico"; break;
        case 20 : texte = "N : Plaine d'Hyrule"; break;
        case 21 : texte = "O : Terres de Feu"; break;
        case 22 : texte = "E : Village de l'Ombre*- Dconseill aux vivants -"; break;
        case 23 : texte = "Temple des Tnbres**Si vous tes un fantme et que vous cherchez un job, venez plutt chmer ici."; break;
        case 24 : texte = "N : Village de l'Ombre*O : Lac Hylia"; break;
        case 25 : texte = "N : Cimetire Hant**Entre interdite"; break;
        case 26 : texte = "Village de l'Ombre"; break;
        case 27 : texte = "Je vends un flacon pour 100 rubis, a vous intresse ?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->hasBouteille(0) && gpJeu->getZone()==8
            || gpJeu->getJoueur()->hasBouteille(1) && gpJeu->getZone()==5
            || gpJeu->getJoueur()->hasBouteille(2) && gpJeu->getZone()==6) {id=32; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<100) idsuiv=29;
            else idsuiv=30;
            break;
        case 28 : texte = "Je vends un flacon pour 100 rubis, a vous intresse ?*              oui              NON ?"; idsuiv=31; break;
        case 29 : texte = "Dsol, mais vous n'avez pas assez de rubis."; break;
        case 30 : texte = "Merci beaucoup, voil votre flacon."; break;
        case 31 : texte = "Revienez me voir si vous changez d'avis."; break;
        case 32 : texte = "Dsol, c'tait mon seul flacon."; break;
        case 33 : texte = "Vous avez trouv un flacon vide !!!**Vous allez pouvoir vous en servir pour stocker des potions !"; break;
        case 35 : texte = "Les habitants de ce village ont un dialecte trs particulier, je n'y comprends rien..."; break;
        case 36 : texte = "@+@+@+@+@+@+@@@+*@=++=@=+@=+@=+=@*+@+@+@+=+="; break;
        case 37 : texte = "Obtienez une autorisation du chef si vous voulez vraiment passer!!!"; break;
        case 38 : texte = "Le chef vous a autoris  passer ??? Grrrr... Alors cartez vous!!!"; break;
        case 39 : texte = "Ne trane pas dans mes pattes !!!"; break;
        case 40 : texte = "On n'a pas l'habitude de voir des visiteurs par ici..."; break;
        case 41 : texte = "Les monstres du coin ne craignent pas grand chose, heureusement qu'ils n'attaquent que les humains."; break;
        case 42 : texte = "C'est vrai ?*Tu comprends ce que je dis ?"; break;
        case 43 : texte = "N : Dsert et Village Gerudo"; break;
        case 44 : texte = "S : Lac Hylia*O : Chteau d'Hyrule"; break;
        case 45 : texte = "Village Cocorico"; break;
        case 46 : texte = "O : Chteau d'Hyrule"; break;
        case 47 : texte = "Quelle belle journe !!!"; break;
        case 48 : texte = "Pourquoi ai-je accept de m'occuper de ces salets ???*J'ai horreur des poules !!!"; break;
        case 49 : texte = "On trouve des tas de choses dans les boutiques du village."; break;
        case 50 : texte = "S : Village Cocorico*O : Dsert*E : Mont du Pril"; break;
        case 51 : texte = "Village Gerudo"; break;
        case 52 : texte = "Perdu dans le dsert ?*Vous tes ici :*                        X"; break;
        case 54 : texte = "S : Vers le Chteau d'Hyrule"; break;
        case 55 : texte = "Temple du Dsert**Venez essayer nos bains.*(eau non-potable)"; break;
        case 56 : texte = "Temple de la Fort**Sauvez les arbres, mangez du castor!!!"; break;
        case 57 : texte = "Temple du Lac**Bonnet de bain obligatoire."; break;
        case 58 : texte = "Temple de Glace**Le personnel tient  rappeler qu'un donjon n'est pas une patinoire."; break;
        case 59 : texte = "Avez-vous t voir le forgeron de ce village ?*On dit qu'il est trs dou pour amliorer l'quipement des aventuriers, beaucoup de monde lui rend visite."; break;
        case 60 : texte = "Le temple se trouve au fin fond du dsert,  la place d'une ancienne oasis."; break;
        case 61 : texte = "S : Terres de Feu*E : Village Cocorico"; break;
        case 62 : texte = "Chteau d'Hyrule"; break;
        case 63 : texte = "E : Village Cocorico"; break;
        case 64 : texte = "O : Roc de la Tortue*E : Lac Hylia"; break;
        case 65 : texte = "Temple Cach**Ici repose les lames purificatrices, Excaliburs."; break;
        case 66 : texte = "N : Vers le cimetire hant"; break;
        case 67 : texte = "Vous avez trouv la carte du donjon !!!*Appuiez sur P pour voir le plan."; break;
        case 68 : texte = "Vous avez trouv la boussole !!!*Vous pouvez localiser le boss et les coffres sur le plan."; break;
        case 69 : texte = "Vous avez trouv la cl du boss !!!"; break;
        case 70 : texte = "Vous avez trouv une petite cl !!!*Approchez une porte pour l'ouvrir."; break;
        case 71 : texte = "Vous avez trouv les gants !!!*Utilisez-les pour soulever des objets en les quipant ou en appuyant sur C."; break;
        case 72 : 
            texte = "Vous avez trouv un cristal magique !!!"; 
            tmp = 7-gpJeu->getJoueur()->nbCristaux();
            os << tmp;
            if (tmp==6 && !gpJeu->getJoueur()->getAvancement()) buffer = "A quoi pourra-t-il bien servir ?";
            else if (tmp>2) buffer = "Il en reste encore "+os.str()+"  trouver !!!";
            else if (tmp==2) buffer = "Plus que 2  trouver !!!";
            else if (tmp==1) buffer = "Il ne t'en manque plus qu'un seul !!!";
            else if (tmp==0) buffer = "Vous avez  tous les cristaux, cours au chteau sauver Zelda !!!";
            break;
        case 80 : texte = "Vous avez trouv 2 grappins !!!*Utilisez-les pour franchir des obstacles."; break;
        case 81 : texte = "Vous avez trouv 2 lanternes !!!*Utilisez-les pour faire jaillir des flammes."; break;
        case 82 : texte = "Vous avez trouv 2 paires de palmes !!!*Equipez-les pour aller dans l'eau."; break;
        case 83 : texte = "Vous avez trouv 2 marteaux magiques !!!*Utilisez-les pour craser les obstacles."; break;
        case 84 : texte = "Vous avez trouv 2 batons de feu !!!*Vous peux dsormais lancer de puissantes flammes  distance."; break;
        case 85 : texte = "Vous avez trouv 2 batons de glace !!!*Utilisez-les pour tout congeler  distance."; break;
        case 86 : texte = "Vous avez trouv les 2 Excaliburs !!!*Mme Ganon ne devrait pas pouvoir rsister  sa puissance !!! (en thorie)"; break;
        case 87 : texte = "Flicitation les Link, Vous avez russi  venir me dlivrer!!!***Allons vite trouver Ganon, il faut imprativement lui reprendre la Triforce !"; break;
        case 89 : texte = "Le passage secret derrire la salle du trne mne  Ganon. Dpchons-nous !"; break;
        case 90 : texte = "Nous y sommes presque, suivez-moi !"; break;
        case 91 : texte = "J'ai bien peur que vous ne puissiez jamais vaincre Ganon avec tes armes actuelles...*Va parler au chef du village Cocorico, je suis sre qu'il trouvera une solution."; break;
        case 92 : texte = "Ganon est juste derrire cette porte, je vais soigner vos blessures."; break;
        case 93 : texte = "Ganon est toujours quelque part dans le chteau."; break;
        case 94 : texte = "Vous devriez attendre la princesse Zelda !!!"; break;
        case 95 : texte = "Tu n'aurais pas l'trange sentiment d'oublier quelqu'un par hasard ???"; break;
        case 96 : texte = "Zelda t'attend!!!"; break;
        case 97 : texte = "Vous avez trouv la Triforce!!!"; break;
        case 98 : texte = "Vous avez trouv le livre de Mudora!!!**Vous comprendez dsormais le Hylien ancien!!!"; break;
        case 99 : texte = "Flicitation Links, vous avez russi  me trouver. En rcompense, je vous offre le mdaillon de Din, il augmente vos dfenses d'un point."; break;
        case 100 : texte = "Flicitation Links, vous avez russi  me trouver. En rcompense, je vous offre le mdaillon de Nayru, il augmente vos dfenses de deux points!"; break;
        case 101 : texte = "..."; break;
        case 102 : texte = "Vous avez obtenu un mdaillon magique !!!**Vos dfenses viennent d'augmenter!!!"; break;
        case 103 : texte = "Flicitation Links, vous avez russi  me trouver. Pour vous rcompenser, je vais doubler la capacit de vos rserves de magie!!!"; break;
        case 104 : texte = "vos rserves de magie ont doubl!!!"; break;
        case 105 : texte = "Reviens me voir quand vous aurez un flacon vide  et je vous vendrai une potion rouge qui restaure l'nergie."; break;
        case 106 : texte = "Une potion rouge pour 60 rubis, a vous intresse?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=105; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<60) idsuiv=29;
            else idsuiv=108; break;
        case 107 : texte = "Une potion rouge pour 60 rubis, a vous intresse?*              oui              NON ?"; break;
        case 108 : texte = "Merci, voil votre potion.";break;
        case 109 : texte = "Vous avez obtenu une potion rouge !!!*Buvez-la pour restaurer votre nergie!!!"; break;
        case 110 : texte = "Vous avez obtenu une potion verte !!!*Buvez-la pour restaurer votre magie!!!"; break;
        case 111 : texte = "Vous avez obtenu une potion bleue !!!*Buvez-la pour restaurer votre nergie et votre magie!!!"; break;
        case 112 : texte = "Bonjour, je vous sers quelque chose ?"; break;
        case 113 : texte = "Hic! On raconte qu'une fe donnerait des objets enchants... Hic! ...aux aventuriers qui la  trouveraient... Hic!!!"; break;
        case 114 : texte = "Un coeur pour 10 rubis, ok ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getVie()+gpJeu->getJoueur()->getBoostVie()
            == gpJeu->getJoueur()->getVieMax()) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=29;
            else idsuiv=129; break;
        case 115 : texte = "Un coeur pour 10 rubis, ok ?**              oui              NON ?"; break;
        case 116 : texte = "Un peu de magie pour 20 rubis, ok ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getMagie()+gpJeu->getJoueur()->getBoostMagie()
            == gpJeu->getJoueur()->getMagieMax() || !gpJeu->getJoueur()->hasObjet(O_LANTERNE)) {
                id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<20) idsuiv=29;
            else idsuiv=129; break;
        case 117 : texte = "Un peu de magie pour 20 rubis, ok ?**              oui              NON ?"; break;
        case 118 : texte = "Beaucoup de magie pour 30 rubis, ok ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getMagie()+gpJeu->getJoueur()->getBoostMagie()
            == gpJeu->getJoueur()->getMagieMax() || !gpJeu->getJoueur()->hasObjet(O_LANTERNE)) {
                id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 119 : texte = "Beaucoup de magie pour 30 rubis, ok ?**              oui              NON ?"; break;
        case 120 : texte = "5 flches pour 30 rubis, ok ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getFleche() == gpJeu->getJoueur()->getFlecheMax() 
            || !gpJeu->getJoueur()->hasObjet(O_ARC)) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 121 : texte = "5 flches pour 30 rubis, ok ?**              oui              NON ?"; break;
        case 122 : texte = "Une bombe pour 30 rubis, ok ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getBombe() == gpJeu->getJoueur()->getBombeMax() 
            || !gpJeu->getJoueur()->hasObjet(O_SAC_BOMBES)) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 123 : texte = "Une bombe pour 30 rubis, ok ?**              oui              NON ?"; break;
        case 124 : texte = "Un arc pour 1000 rubis, ok ?**              OUI ?            non  "; 
            idsuiv=29; break;
        case 125 : texte = "Un arc pour 1000 rubis, ok ?**              oui              NON ?"; break;
        case 126 : texte = "Un arc pour 50 rubis, ok ?**              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<50) idsuiv=29;
            else idsuiv=129; break;
        case 127 : texte = "Un arc pour 50 rubis, ok ?**              oui              NON ?"; break;
        case 128 : texte = "Tu n'as pas besoin de a maintenant."; break;
        case 129 : texte = "Merci."; break;
        case 130 : texte = "Vous avez obtenu 2 arcs !!!*Utilisez-les pour atteindre des cibles loignes."; break;
        case 131 : texte = "Choisissez ce que vous voulez."; break;
        case 132 : texte = "Hein ???*Vous etes en mission pour le chef ???*Bon alors je vais vous faire une rduction sur l'arc..."; break;
        case 133 : texte = "Bonjour les Links, je suis le chef de ce village, je me doutais que vous passeriez."; idsuiv=134; break;
        case 134 : texte = "Depuis ce matin des monstres sont apparus un peu partout  Hyrule, j'ai voulu aller en parler  la princesse Zelda, mais comme vous l'avez peut-tre dj vu, un sortilge bloque l'accs au chteau..."; idsuiv=136; break;
        case 136 : texte = "Vous dites que Ganon est responsable de tout a ? Qu'il a vol la Triforce et qu'il dtient la princesse Zelda prisonnire ?"; idsuiv=137; break;
        case 137 : texte = "Mmmm... la situation est plus grave que je le croyais..."; idsuiv=138; break;
        case 138 : texte = "Il faut agir au plus vite, vous doivez affronter Ganon  nouveau!"; idsuiv=139; break;
        case 139 : texte = "Comment entrer dans le chteau ? J'ai peut-tre une ide..."; idsuiv=140; break;
        case 140 : texte = "Comme vous le savez, le pouvoir des 7 sages a t enferm dans 7 cristaux par le sorcier Aghanim alors qu'il tentait de lever le sceau qui confinait Ganon au monde des tnbres."; idsuiv=141; break;
        case 141 : texte = "Or, bien que vous ayez ressuscit les descendants des sages aprs avoir vaincu Ganon et trouv la Triforce, ces cristaux ont conserv leur puissance."; idsuiv=142; break;
        case 142 : texte = "Ils ont t cachs au fin fond des 7 temples, runissez-les tous et vous pourrez passer outre le sortilge de Ganon."; idsuiv=143; break;
        case 143 : texte = "Ce ne sera toutefois pas chose ais, Ganon a certainement d envoyer ses meilleurs lments protger ces cristaux..."; idsuiv=144; break;
        case 144 : texte = "Une dernire chose, vous n'irez pas loin avec vos quipements actuels. Allez voir le marchand d'armes et dites-lui que vous venez de ma part. Il fera srement un geste pour vous."; break;
        case 145 : texte = "Allez voir le marchand d'armes et dis-lui que vous viennez de ma part, il fera certainement un geste pour vous."; break;
        case 146 : texte = "Il vous faut rassembler les 7 cristaux pour avoir une chance de sauver Zelda et Hyrule..."; break;
        case 147 : texte = "Tu as trouv les 7 cristaux ? Alors rends-toi au chteau, vous devez avant tout dlivrer la princesse, elle saura mieux que moi comment sauver Hyrule."; break;
        case 148 : texte = "Vos armes sont sans effet sur Ganon ? Dans ce cas vous devez trouver les Excaliburs. On raconte qu'elles oont t dissimule dans un temple cach.*On dit aussi que le chemin menant aux lames purificatrices passe par un village peupl de monstres...*Je me demande si un tel village existe..."; break;
        case 150 : texte = "Toutefois j'ai bien peur que vos quipements actuels soit insuffisant pour accder  ce temple, vous devriez peut-tre passer voir le forgeron du village Gerudo..."; break;
        case 151 : texte = "Il est temps d'affronter Ganon et de lui reprendre la Triforce!"; break;
        case 152 : texte = "Hey! Il faut payer pour ouvrir un de mes coffres!!!"; break;
        case 153 : texte = "Un de ces coffres contient un quart de coeur, vous voulez tenter votre chance pour 10 rubis ?*Vous ne pourrez ouvrir qu'un seul coffre, ok ?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=29; break;
        case 154 : texte = "Un de ces coffres contient un quart de coeur, vous voulez tenter votre chance pour 10 rubis ?*Vous ne pourrez ouvrir qu'un seul coffre, ok ?*              oui              NON ?"; break;
        case 155 : texte = "Choisissez un coffre."; break;
        case 156 : texte = "Je n'ai plus de prix  mettre en jeu, dsol."; break;
        case 157 : texte = "Perdu! Ce coffre est vide."; break;
        case 158 : texte = "Bonjour! Si vous tes venu voir le forgeron, il habite un peu plus loin."; break;
        case 159 : texte = "Bonjour les Links, je suis le chef de ce village.*Vous devriez aller voir le forgeron et lui prsenter ce que vous voulez qu'il reforge dans votre quipement.";
            buffer = "J'ai t inform devotre qute, alors je me suis arrang avec lui.*Tout sera gratuit pour vous."; break;
        case 160 : texte = "Tu n'as pas besoin de boire cette potion maintenant."; break;
        case 161 : texte = "Une potion verte pour 40 rubis, a vous intresse?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=163; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<40) idsuiv=29;
            else idsuiv=108; break;
        case 162 : texte = "Une potion verte pour 40 rubis, a vous intresse?*              oui              NON ?"; break;
        case 163 : texte = "Reviennez me voir quand vous aurez un flacon vide et je vous vendrai une potion verte qui restaure la magie."; break;
        case 164 : texte = "Reviennez plus tard, je suis dbord!"; break;
        case 165 : texte = "Puis-je faire quelque chose pour vous ?";
            if (gpJeu->getJoueur()->getEpee()==1) {id=166; chercheText();break;}
            if (gpJeu->getJoueur()->hasObjet(O_GANTS)==1 && gpJeu->getJoueur()->getObjet()==8) {
                id=169; chercheText();break;}
            if (gpJeu->getJoueur()->hasObjet(O_ARC)==2 && gpJeu->getJoueur()->getObjet()==0 
            && gpJeu->getJoueur()->nbCristaux()==7) {
                id=172; chercheText();break;}
            break;
        case 166 : texte = "Voulez-vous que je reforge vos pes ?**              OUI ?            non  "; break;
        case 167 : texte = "Voulez-vous que je reforge vos pes ?**              oui              NON ?"; break;
        case 168 : texte = "Vos pes ont tripl de puissance et peuvent dsormais renvoyer certaines attaques magiques, trop bien !!!*"; break;
        case 169 : texte = "Voulez-vous que j'amliore vos gants ?**              OUI ?            non  "; break;
        case 170 : texte = "Voulez-vous que j'amliore vos gants ?**              oui              NON ?"; break;
        case 171 : texte = "La puissance de vos gants va vous permettre de soulever de lourds rochers."; break;
        case 172 : texte = "Voulez-vous que j'amliore vos arcs ?**              OUI ?            non  "; break;
        case 173 : texte = "Voulez-vous que j'amliore vos arcs ?**              oui              NON ?"; break;
        case 174 : texte = "Vos arcs tirent dsormais des flches d'argent d'une puissance dvastatrice!!!"; break;
        case 175 : texte = "Reviennez me voir quand vous aurez un flacon vide et je vous vendrai une potion bleue qui restaure l'nergie et la magie."; break;
        case 176 : texte = "Une potion bleue pour 160 rubis, a vous intresse?*              OUI ?            non  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=175; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<160) idsuiv=29;
            else idsuiv=108; break;
        case 177 : texte = "Une potion bleue pour 160 rubis, a vous intresse?*              oui              NON ?"; break;
        case 178 : texte = "Notre village a t fond pour empcher les aventuriers imprudents d'accder au temple, je ne donne pas l'autorisation de passer  n'importe qui."; break;
        case 179 : texte = "Mmmm... Vous avez dj trouv 4 cristaux ?*Je dois avouer que vous m'impressionnez...";
            buffer = "Bon c'est entendu, vous avez l'autorisation de passer par le cimetire,  vos risques et prils."; break;
        case 181 : texte = "allez parler au garde au nord du village, il vous laissera passer."; break;
        case 182 : texte = "Je vois que vous etes toujours vivant...*Etonnant."; break;
        case 183 : texte = "Le temple de l'ombre constitue le point de dpart du chemin menant  un objet de lgende. Ce village ne sert qu' dissuader les aventuriers de trop s'en approcher."; break;
        case 184 : texte = "Ainsi vous avez trouv les 2 Epes ?*Mais ne croyez pas qu'elles soient  vous pour autant.";
            buffer = "les Excaliburs font partie du patrimoine le plus prcieux d'Hyrule avec la Triforce, vous devrez les ramener dans leu sanctuaire une fois ta mission acheve."; break;
        case 186 : texte = "Les habitants de ce village sont tous des esprits ayant rpondu  l'appel de la princesse Zelda."; break;
        case 187 : texte = "Lorsque vous avez ramen la paix sur Hyrule et runifi le monde de la lumire avec la Terre d'Or, Zelda a secrtement demand aux esprits volontaires de crer ce village pour bloquer";
            buffer = "l'accs  un objet de trs grande valeur."; break;
        
        case 189 : texte = "Bienvenue les Links!*Laissez-moi vous expliquer ce que je fais ici."; idsuiv=190; break;
        case 190 : texte = "Comme vous l'avez certainement remarqu, des monstres sont apparus partout dans Hyrule. C'est la premire fois que je vois des monstres depuis que vous avez vaincu Ganon."; idsuiv=191; break;
        case 191 : texte = "Et bien j'ai dcid de tous les rpertorier."; idsuiv=192; break;
        case 192 : texte = "L'ennui c'est que je suis bien trop peureux pour aller  leur rencontre, alors j'ai besoin de votre aide."; idsuiv=193; break;
        case 193 : texte = "Il faut que vous battiez chaque type de monstre et que vous vienniez me faire votre rapport."; idsuiv=194; break;
        case 194 : texte = "Je vous rcompenserai tous les 7 nouveaux types d'ennemis vaincus."; idsuiv=195; break;
        case 195 : texte = "Si vous voullez savoir quels ennemis vous avez dj vaincu, appuye sur M."; break;
        
        
        case 196 : 
            if (gpJeu->getJoueur()->getCoeur(43)) {
                if (gpJeu->getJoueur()->nbEnnemis() >= 46) {id=205; chercheText();return;}
                else {id=204; chercheText();return;}
            }
            for (int i = 38; i < 44; i++) 
                if (!gpJeu->getJoueur()->getCoeur(i) 
                && (gpJeu->getJoueur()->nbEnnemis()/7)+37>=i) {
                    id=203; chercheText();return;
                }
            tmp = 7-(gpJeu->getJoueur()->nbEnnemis()%7);
            os << tmp;
            if (tmp>1) texte = "Encore "+os.str()+" ennemis diffrents avant la prochaine rcompense.";
            else texte = "Plus qu'un nouvel ennemi avant la prochaine rcompense!!!";
            break;
        case 203 : texte = "Acceptez ce cadeau pour votre contribution  mon projet :"; break;
        case 204 : texte = "Je suis dsol mais je n'ai plus rien  vous offrir..."; break;
        case 205 : texte = "Je n'en crois pas mes yeux, vous avez russi  vaincre chaque type d'ennemis !!!*Flicitation les Links!!!"; break;
        
        case 206 : texte = "                   Niveau 1 :**               Temple de la fort"; break;
        case 207 : texte = "                   Niveau 2 :**                 Temple de l'eau"; break;
        case 208 : texte = "                   Niveau 3 :**              Temple de la montagne"; break;
        case 209 : texte = "                   Niveau 4 :**                Temple du dsert"; break;
        case 210 : texte = "                   Niveau 5 :**                Temple de l'ombre"; break;
        case 211 : texte = "                   Niveau 6 :**                  Temple du feu"; break;
        case 212 : texte = "                   Niveau 7 :**                Temple de la glace"; break;
        case 213 : texte = "                   Niveau ? :**                   Temple secret"; break;
        case 214 : texte = "                 Niveau Final :**                Chteau d'Hyrule"; break;
        
        case 215 :texte = "                Dj fatigu ?                  ?                CONTINUER                  ?             Sauvegarder et quitter                        Quitter sans sauvegarder           "; break;
        case 216 :texte = "                Dj fatigu ?                                   Continuer                     ?          SAUVEGARDER ET QUITTER           ?            Quitter sans sauvegarder           "; break;
        case 217 :texte = "                Dj fatigu ?                                   Continuer                                Sauvegarder et quitter              ?         QUITTER SANS SAUVEGARDER          ?"; break;
        
        case 223 : texte = "A l'instant o les Links touchrent la Triforce, les monstres disparurent et la paix revint.**La princesse Zelda prit alors une grande dcision: elle toucha  son tour la Triforce pour exaucer son voeu...**La Triforce fut depuis toujours  l'origine des problmes survenus au Royaume, tt ou tard un autre tre malfaisant aurait fini par la trouver.**A la seconde o la princesse toucha la relique, elle disparue  jamais d'Hyrule.";
            buffer = "Depuis ce jour, le peuple d'Hyrule vcut en paix, sans craindre de nouveaux dsastres.**Ainsi s'achve la lgende de Zelda, celle de la  Triforce et de la Terre d'Or.**On dit que les pes Excaliburs reposent en sret quelque part, et qu'elles constituent le dernier souvenir de la qute des Links..."; break;
        case 224 : texte = "Flicitation les Links, vous avez russi  me trouver. En rcompense, je vous offre le mdaillon de Farore, il augmente votre dfense d'un point."; break;
        case 225 : texte = "Souhaitez-vous sauvegarder votre partie ?**                    ? OUI ?*                      non  "; break;
        case 226 : texte = "Souhaitez-vous sauvegarder votre partie ?**                      oui  *                    ? NON ?"; break;
        case 227 : texte = "Partie sauvegarde."; break;
        
        case 228 : texte = "Le Royaume d'Hyrule tait en paix depuis que les Links, derniers chevaliers hylien, avaient vaincu le malfique Ganon et lui avaient repris la prcieuse Triforce."; idsuiv = 229; break;
        case 229 : texte = "Nul ne sait quel voeu firent les Links en touchant la Triforce, mais il eut comme effet de runifier le monde de la lumire et celui des tnbres, et ramena  la vie les descendants des 7 sages."; idsuiv = 230; break;
        case 230 : texte = "Les Links remirent ensuite  la princesse Zelda la Triforce et les pes Excaliburs, et le peuple se mit  croire que la paix durerait.*Mais le peuple se trompait..."; idsuiv=231; break;
        case 231 : texte = "Le souhait de Link  la Triforce eu hlas de fcheux effets. Ganon et ses sbires furent ainsi ressuscits et s'apprtrent  attaquer."; idsuiv=232; break;
        case 232 : texte = "Quelque part dans la fort d'Hyrule, les Links dorment sans se douter que Ganon est pass  l'attaque, jusqu' ce qu'une voix familire leur parle dans leur sommeil..."; break;
        case 233 : texte = "A l'aide!*A l'aide!*C'est moi! C'est Zelda!*Je vous parle par tlpathie."; idsuiv = 234; break;
        case 234 : texte = "Je suis retenue prisonnire dans le donjon du chteau! J'ai besoin de votre aide!*Ganon est de retour, et il a certainement d trouver la Triforce  l'heure qu'il est..."; idsuiv=235; break;
        case 235 : texte = "Venez vite au chteau les Links, vous etes mon seul espoir..."; break;
        case 236 : texte = "AIDE : Appuie sur F1 pour consulter l'aide."; break;
    }
    
    
}

void Texte::affiche(SDL_Surface* gpScreen, std::string s, int a, int b) {
    for (int i = 0; i < (int)s.length(); i++) {
        afficheLettre(gpScreen, s.at(i),a,b);
        a+=6;
    }
}

void Texte::draw(SDL_Surface* gpScreen) {
    
    if (cadre) drawCadre(gpScreen);
    
    if (id==3 && texte == "Vous avez trouv un quart de coeur !!!") {
        SDL_Rect src; SDL_Rect dst;
        src.x=16*(gpJeu->getJoueur()->nbQuarts()%4);
        if(src.x==0)src.x=16*4;
        src.y=0; src.w=16; src.h=16; dst.x=160-8; dst.y=120-8+16*5;
        SDL_BlitSurface(imageCoeur, &src, gpScreen, &dst);
    }
    
    int a = x+8; int b = y+8;
    for (int i = 0; i < av; i++) {
        afficheLettre(gpScreen, texte.at(i),a,b);
        a+=6;
        if (a > x+w-16) {a=x+8; b+=16;}
    }
    
    if(SDL_GetTicks() > lastAnimTime + vitesse && def && av < (int)texte.length()) {
        lastAnimTime = SDL_GetTicks();
        do av++;
        while (av < (int)texte.length() && texte.at(av-1) == ' ');
        if (texte.at(av-1) != ' ') gpJeu->getAudio()->playSound(0,1);
    }
}

bool Texte::isFinished() {return (av==(int)texte.length());}

int Texte::getId() {return id;}

void Texte::changeId(int i) {
    id=i; idsuiv=0; buffer="";
    chercheText();
    decoupeText();
    if (av>(int)texte.length()) av=(int)texte.length();
}

void Texte::drawCadre(SDL_Surface* gpScreen) {
    SDL_Rect src;
    SDL_Rect dst;
    
    src.w=8; src.h=8; src.x = 103; src.y = 100; dst.x = x; dst.y = y;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.y = 109; src.w=8;
    for (int j = 8; j < h-8; j+=16) {
        dst.y = y + j;
        src.x = 103; dst.x = x; src.h=16;
        while (dst.y + src.h > y+h && src.h>0) src.h--;
        if (src.h>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
        src.x = 129; dst.x = x+w-8;
        if (src.h>0)SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.h=8; src.x = 103; src.y = 126; dst.x = x; dst.y = y+h-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

void Texte::setTexte(int idTxt, int vx, int vy, int vw, int vh, bool cadr, bool defil, int vit) {
    if (idTxt == 0) return;
    id = idTxt; 
    idsuiv = 0;
    buffer = "";
    chercheText();
    
    x = vx; y = vy; w = vw; h = vh;
    decoupeText();
        
    def=defil;
    if (def) av = 0;
    else av = texte.length();
    
    cadre = cadr;
    
    vitesse = vit;
}

void Texte::decoupeText() {
    //compte le nombre de caractres possibles et largeur et en hauteur
    int nbcol = (w-16)/6 -1;
    int nblig = (h-16)/16;
    int tailleMax = nbcol * nblig;
    int taille;
    
    //parcours du texte  afficher;  chaque dbut de mot, 
    //vrifie que le mot peut tenir sur la ligne
    for (int i = 0; i < (int)texte.length(); i++) {
        
        //supprime les espaces isols en dbut de ligne
        if (texte.at(i)==' ' && texte.at(i+1)!=' ' && i%nbcol == 0) texte.erase(i,1);
        //recherche du dbut du prochain mot
        while(texte.at(i)==' ' && i < (int)texte.length()-1) i++;
        
        //saute une ligne si trouve une toile
        if (texte.at(i)=='*') {
            texte.erase(i,1);//replace(i, 1, " ");
            int nb = (nbcol)-(i%(nbcol));
            for (int j = 0; j < nb; j++) texte.insert(i," ");
            continue;
        }
        
        //si le mot dpasse
        taille = tailleMot(i);
        if ((i%nbcol)+taille>nbcol) {
            if  (i < tailleMax) {
                //si le mot ne tient pas sur une ligne, on le coupe avec des tirets
                if (taille>nbcol) {
                    texte.insert(((i/nbcol)+1)*nbcol-1,"--");
                    i = 1+((i/nbcol)+1)*nbcol;
                }
                //sinon, on ajoute des espaces pour faire commencer le mot  la ligne
                else while((i%nbcol) != 0) {texte.insert(i," "); i++;}
            }
        }
        
    }
    
    // si le texte est trop grand, on le coupe en deux
    if ((int)texte.length() > tailleMax) {
        buffer = texte.substr(tailleMax);
        texte = texte.substr(0, tailleMax);
    }
}

int Texte::tailleMot(int deb) {
    int i = deb;
    int total = 0;
    while (texte.at(i)!=' ') {total++; i++; if (i >= (int)texte.length()) return total;}
    return total;
}

void Texte::afficheLettre(SDL_Surface* gpScreen, char c, int vx, int vy) {
    SDL_Rect src;
    SDL_Rect dst;
    
    int val = (int)c;
    
    dst.x=vx; dst.y=vy;
    src.h=16;src.w=8;
    
    if(val==32) return;
    
    // /
    if(val==47) {src.x=52;src.y=151;}
    
    // @ hylien
    if(val==64) {src.x=4;src.y=151;}
            
    // + hylien
    if(val==43) {src.x=20;src.y=151;}
            
    // = hylien
    if(val==61) {src.x=36;src.y=151;}
            
    //minuscules a-z
    if(val>=97 && val<=122) {src.x=4+16*((val-97)%10); src.y=52+16*((val-97)/10);}
            
    //majuscules A-Z
    if(val>=65 && val<=90) {src.x=6+16*((val-65)%10); src.y=2+16*((val-65)/10);}   
    // 
    if(val==-25) {src.x=148;src.y=34;}
    // 
    if(val==-23) {src.x=100;src.y=84;}
    // 
    if(val==-22) {src.x=116;src.y=84;}
    // 
    if(val==-24) {src.x=132;src.y=84;}
    // 
    if(val==-21) {src.x=132;src.y=151;}
    // 
    if(val==-32) {src.x=148;src.y=84;}
    // 
    if(val==-30) {src.x=148;src.y=103;}
    // 
    if(val==-28) {src.x=148;src.y=135;}
    // 
    if(val==-18) {src.x=84;src.y=119;}
    // 
    if(val==-17) {src.x=116;src.y=151;}
    // 
    if(val==-5) {src.x=84;src.y=103;}
    // 
    if(val==-7) {src.x=148;src.y=151;}
    // 
    if(val==-4) {src.x=116;src.y=135;}
    // 
    if(val==-10) {src.x=132;src.y=135;}
    // 
    if(val==-12) {src.x=148;src.y=119;}
            
    //ponctuation
    // -
    if(val==45) {src.x=102;src.y=34;}
    // .
    if(val==46) {src.x=118;src.y=34;}
    // ,
    if(val==44) {src.x=134;src.y=34;}
    // !
    if(val==33) {src.x=3;src.y=135;}
    // ?
    if(val==63) {src.x=19;src.y=135;}
    // (
    if(val==40) {src.x=35;src.y=135;}
    // )
    if(val==41) {src.x=51;src.y=135;}            
    // ' ( avec @ )
    if(val==39) {src.x=67;src.y=135;}
    // :
    if(val==58) {src.x=83;src.y=135;}
    // ... ( avec % )
    if(val==37) {src.x=101;src.y=135;}
    // >
    if(val==62) {src.x=100;src.y=151;}
    // <
    if(val==60) {src.x=84;src.y=151;}
            
    //chiffres            
    if(val>=48 && val<=57) {src.x=3+16*((val-48)%5); src.y=103+16*((val-48)/5);}
    
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

bool Texte::hasNext() {
    return (buffer != "" || idsuiv > 0);
}

bool Texte::suite() {
    if (av < (int)texte.length()) {
        av = texte.length();
        return true;
    }
    if (!hasNext()) {
        gpJeu->getAudio()->playSound(18);
        return gpJeu->finTexte(id);
    }
    if (buffer != "") {
        texte = buffer;
        buffer = "";
    }
    else {
        id = idsuiv;
        idsuiv = 0;
        chercheText();
    }
    decoupeText();
    if (def) av = 0;
    else av = texte.length();
    gpJeu->getAudio()->playSound(17);
    return true;
}
